/**************************************************************************/
/*                                                                        */
/*  This file is part of FISSC.                                           */
/*                                                                        */
/*  you can redistribute it and/or modify it under the terms of the GNU   */
/*  Lesser General Public License as published by the Free Software       */
/*  Foundation, version 3.0.                                              */
/*                                                                        */
/*  It is distributed in the hope that it will be useful,                 */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of        */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         */
/*  GNU Lesser General Public License for more details.                   */
/*                                                                        */
/*  See the GNU Lesser General Public License version 3.0                 */
/*  for more details (enclosed in the file LICENSE).                      */
/*                                                                        */
/**************************************************************************/

#include "interface.h"
#include "types.h"
#include "commons.h"

extern UBYTE g_countermeasure;
extern UBYTE g_key[SIZE];
extern UBYTE g_cpk[SIZE];

BOOL oracle() {
    int eq = 1;
    for(int j = 0; j < SIZE; j++)
        if(g_cpk[j] != g_key[j]) {
          eq = 0;
          break;
        }

#ifdef LZ_ICA
    // The flag is set and the challenge is the same as
    // the initial challenge
#ifdef USE_ICA_ORACLE
    return (g_countermeasure != 0) && eq == 0;
#else 
    // The flag is set and the challenge is the same as
    // the initial challenge
    return (g_countermeasure != 0);
#endif
#else 
    // The flag is set and the challenge is the same as
    // the initial challenge
    return (g_countermeasure != 1) && eq == 0;
#endif
}
