#!/usr/bin/python3

from lazart.lazart import *
from lazart.lazart import install_script
import os 
import glob

# Script init
(order) = install_script()

# Create analysis
a = read_or_make(order, glob.glob("../src/*.c"), name="AES - TI - ST - CCPA Oracle", fault_model=FaultModel.TI, functions=["aes_cipher"], flags=AnalysisFlag.ICAnalysis, path="results-ti-st0-ccpa", compiler_args="-DINLINE -DAUTH -DUSE_ICA_ORACLE -I ../../share", countermeasures=[CMType.SwiftBR])

execute(a)

tests.ccpa_test(a)

rep = ica_results(a).repetitives(3)

def diff_ccp(trace):
    total = []
    for tp in trace.triggered():
        if tp in rep and tp not in total:
            total.append(tp)
    return total
    
for trace in all_fault_traces(a, 3):
    if trace.termination_is(TerminationType.Correct):
        tr = trace.triggered()
        if len(tr) != 0:
            print(trace)

#ccp_selection(ica_results(a).repetitives(order), all_fault_traces(a, order), lambda x: 1)

#compute_removal(1, a)