/**************************************************************************/
/*                                                                        */
/*  This file is part of FISSC.                                           */
/*                                                                        */
/*  you can redistribute it and/or modify it under the terms of the GNU   */
/*  Lesser General Public License as published by the Free Software       */
/*  Foundation, version 3.0.                                              */
/*                                                                        */
/*  It is distributed in the hope that it will be useful,                 */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of        */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         */
/*  GNU Lesser General Public License for more details.                   */
/*                                                                        */
/*  See the GNU Lesser General Public License version 3.0                 */
/*  for more details (enclosed in the file LICENSE).                      */
/*                                                                        */
/**************************************************************************/

#include "interface.h"
#include "types.h"
#include "commons.h"

extern UBYTE aes_state[16];
extern UBYTE g_countermeasure;

BOOL oracle() {
	UBYTE test_out[16] = {0x39,0x25,0x84,0x1D,0x02,0xDC,0x09,0xFB,0xDC,0x11,0x85,0x97,0x19,0x6A,0x0B,0x32};
	//UBYTE test_pln[16] = {0x32,0x43,0xf6,0xa8,0x88,0x5a,0x30,0x8d,0x31,0x31,0x98,0xa2,0xe0,0x37,0x07,0x34};

	int diff = 0;
	int i;
	for ( i = 0; i < 16; i++ ) {
		if ( test_out[i] != aes_state[i] ) {
			diff = 1;
			break;
		}
	}

#ifdef LZ_ICA
    // The flag is set and the challenge is the same as
    // the initial challenge
#ifdef USE_ICA_ORACLE
    return (g_countermeasure != 0) && diff == 1;
#else 
    return (g_countermeasure != 0);
#endif
#else 
	return g_countermeasure == 0 && diff == 1;
#endif
}
