#include "firmwareUpdater.h"
#include "lazart.h"

// ghost global variables for the oracle 
int triggered=0;  // indicates if the update has been triggered or not
int iscorrupted=0; // indicates if the firmare is corrupted or not 
int updated=0; // indicates if the firmare is updated or not 
int loadAddress=0;  // address where the firmware will be actually loaded

// local variables
int aborted=0;    // indicates if the update is aborted or not

int g_countermeasure = 0;

void countermeasure(int cm_id)
{
    g_countermeasure = 1;
    printf("[CM] trigerred cm %d \n", cm_id);
}


void startUpdate (){
      triggered = 1 ;
}

int dataReceived() {
	return  1;  // no network failure
} 

int triggerUpdate() {
  int requiresUpdate; // indicates if a firware update is required or not ...
  klee_make_symbolic (&requiresUpdate, sizeof requiresUpdate, "requiresUpdate") ; 
  if (requiresUpdate)
	  return 1 ; // update is required
  else 
	  return 0 ; // no update required
} 

void loadFirmware(tpage *copyFirmware) {
      // complete the update by preparing the "reboot" step with the new firmware
      // here simply assigns the memory address where the reboot should take place
     loadAddress = LOAD_ADDRESS ;  
} 

void deleteFirmware(tpage *copyFirmware) {
	// simulate the firmware deletion
	// left empty at this stage ...
} 


tpage *decryptPage(tpage *page) {
	return page ;  // no encryption yet
}

int checkPageIntegrity(tpage buf, int pagenum) {
	int pagecorrect;
	klee_make_symbolic (&pagecorrect, sizeof pagecorrect, "pagecorrect") ; /* to introduce arbitrary corruptions */
	 if (pagecorrect) 
	    return 1 ;  
	 else 
	    return 0 ;
/*
Rk : an extension could be to :
    - introduce faults in the writePage functions
    - compute and add a checksum at the end of the writePage function
    - re-check this checksum here (with some possible faults)
*/
}

void writePage(tpage *dest, tpage *src, int page) {

int i;
for (i=0; i<SIZEP; i++) 
	dest->t[page][i] = src->t[page][i] ;
}



void firmwareUpdater() { 
	tpage network ; // data received from the network
	tpage copyFirmware ; 
	tpage bufferFirmware ; 
	int curPage=0 ;  
	int curByte ;

	copyFirmware.nbPage = 0 ; 

	if (triggerUpdate()) {  // check if an update is required or not
		startUpdate() ;
		curByte = 0 ;
		while (1) {
			// wait for data ...
			if (dataReceived()) {
				bufferFirmware.t[curPage][curByte] = network.t[curPage][curByte] ; // copy each recieved byte in a buffer
				curByte ++ ;
				if (curByte==SIZEP-1) {
					//  a whole page has been received
					curPage ++ ;
					curByte = 0 ;
					// now check page integrity
					if (checkPageIntegrity (bufferFirmware, curPage)) { 
						// page is correct
						writePage(&copyFirmware, decryptPage(&bufferFirmware), curPage); 
					} else {
						// page is incorrect
						iscorrupted = 1 ;
						//aborted=1 ;
					}	
				}	
				
			} ;

			if (curPage==PAGE_NUMBER) { // check if end of transfer
			copyFirmware.nbPage = PAGE_NUMBER ; 
				break ; 
			}
		} 
		

		// check that all pages have been (properly) transfered)
		if (copyFirmware.nbPage != PAGE_NUMBER) {  
			iscorrupted=1;
			aborted=1;
			} ;

		if (!aborted) {
			loadFirmware(&copyFirmware) ;
			updated = 1 ;
			// the firmware is supposed to be correctly updated at this step
		} else { 
			// abort the update process 
			deleteFirmware(&copyFirmware) ;
		}

	} 

}
