/**************************************************************************/
/*                                                                        */
/*  This file is part of FISSC.                                           */
/*                                                                        */
/*  you can redistribute it and/or modify it under the terms of the GNU   */
/*  Lesser General Public License as published by the Free Software       */
/*  Foundation, version 3.0.                                              */
/*                                                                        */
/*  It is distributed in the hope that it will be useful,                 */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of        */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         */
/*  GNU Lesser General Public License for more details.                   */
/*                                                                        */
/*  See the GNU Lesser General Public License version 3.0                 */
/*  for more details (enclosed in the file LICENSE).                      */
/*                                                                        */
/**************************************************************************/

#include "types.h"
#include "interface.h"
#include "commons.h"

// global variables definition
BOOL g_challengeFlag;
UBYTE g_challenge[CHALLENGE_SIZE];
UBYTE g_countermeasure;
UBYTE g_functionStack[MAX_STACK_INDEX];
UBYTE g_stackIndex;
UBYTE g_lastFunction;

void initialize()
{
    g_challengeFlag = BOOL_FALSE;
    for (int i = 0 ; i < CHALLENGE_SIZE; ++i) {
        g_challenge[i] = INITIAL_VALUE;
    }

    g_countermeasure = 0;
    for (int i = 0; i < MAX_STACK_INDEX; ++i) {
        g_functionStack[i] = NO_FUNCTION_ID;
    }
    
    g_stackIndex = 0;
    g_lastFunction = NO_FUNCTION_ID;
}
