/**************************************************************************/
/*                                                                        */
/*  This file is part of FISSC.                                           */
/*                                                                        */
/*  you can redistribute it and/or modify it under the terms of the GNU   */
/*  Lesser General Public License as published by the Free Software       */
/*  Foundation, version 3.0.                                              */
/*                                                                        */
/*  It is distributed in the hope that it will be useful,                 */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of        */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         */
/*  GNU Lesser General Public License for more details.                   */
/*                                                                        */
/*  See the GNU Lesser General Public License version 3.0                 */
/*  for more details (enclosed in the file LICENSE).                      */
/*                                                                        */
/**************************************************************************/

/*$
  @name = GetChallenge_1_HB+VS+DA+SC+LC
  @feature = getChallenge
  @fault-model = test-inversion
  @attack-scenario = oracle
  @countermeasure = Hardened Booleans, Virtual Stack, Double Arguments, Step Counter, Loop Counter
  @maintainers = Etienne Boespflug, VERIMAG
  @authors = Philippe de Choudens, SERTIF Consortium
  @version 2.2
*/

#include "interface.h"
#include "types.h"
#include "commons.h"
#include "lazart.h"

extern void initialize(void);
extern BOOL getChallenge(void);

int main()
{
    initialize();
    getChallenge();
    LAZART_ORACLE(oracle());
}
