/**************************************************************************/
/*                                                                        */
/*  This file is part of FISSC.                                           */
/*                                                                        */
/*  you can redistribute it and/or modify it under the terms of the GNU   */
/*  Lesser General Public License as published by the Free Software       */
/*  Foundation, version 3.0.                                              */
/*                                                                        */
/*  It is distributed in the hope that it will be useful,                 */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of        */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         */
/*  GNU Lesser General Public License for more details.                   */
/*                                                                        */
/*  See the GNU Lesser General Public License version 3.0                 */
/*  for more details (enclosed in the file LICENSE).                      */
/*                                                                        */
/**************************************************************************/

#include "interface.h"
#include "types.h"
#include "commons.h"
#include <stdio.h>

extern SBYTE g_ptc;
extern BOOL g_authenticated;
extern BOOL g_countermeasure;
extern UBYTE g_userPin[PIN_SIZE];
extern UBYTE g_cardPin[PIN_SIZE];

#ifdef INLINE
__attribute__((always_inline)) inline BOOL byteArrayCompare(UBYTE* a1, UBYTE* a2, UBYTE size)
#else
BOOL byteArrayCompare(UBYTE* a1, UBYTE* a2, UBYTE size)
#endif
{
    int i;
    BOOL result = BOOL_TRUE;
    for(i = 0; i < size; i++) {
        if(a1[i] != a2[i]) {
            result = BOOL_FALSE; 
        }
        // result |= a1[i] ^ a2[i]
    }

    if(i != size)
        countermeasure(100);


    return result;
}

BOOL verifyPIN() {
    if(g_ptc > 0) {    
        if(byteArrayCompare(g_userPin, g_cardPin, PIN_SIZE) == BOOL_TRUE) {
            g_authenticated = 1; // Authentication();
            g_ptc = 3;
            return 1;
        } else {
            g_ptc--;
            return 0;
        }
    }

    return 0;
}
