/**************************************************************************/
/*                                                                        */
/*  This file is part of FISSC.                                           */
/*                                                                        */
/*  you can redistribute it and/or modify it under the terms of the GNU   */
/*  Lesser General Public License as published by the Free Software       */
/*  Foundation, version 3.0.                                              */
/*                                                                        */
/*  It is distributed in the hope that it will be useful,                 */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of        */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         */
/*  GNU Lesser General Public License for more details.                   */
/*                                                                        */
/*  See the GNU Lesser General Public License version 3.0                 */
/*  for more details (enclosed in the file LICENSE).                      */
/*                                                                        */
/**************************************************************************/

#include "types.h"
#include "interface.h"
#include "commons.h"
#include <klee/klee.h>

#include <assert.h>

// global variables definition
BOOL g_authenticated;
SBYTE g_ptc;
UBYTE g_countermeasure;
UBYTE g_userPin[PIN_SIZE];
UBYTE g_cardPin[PIN_SIZE];

void initialize()
{
    g_authenticated = 0;
    g_ptc = 3;
    g_countermeasure = 0;
   
    klee_make_symbolic(g_cardPin, sizeof(g_cardPin), "g_cardPin");
    klee_make_symbolic(g_userPin, sizeof(g_userPin), "user_PIN");

    int equal = g_cardPin[0] == g_userPin[0] &&
    g_cardPin[1] == g_userPin[1] &&
    g_cardPin[2] == g_userPin[2] &&
    g_cardPin[3] == g_userPin[3];
    
    klee_assume(!equal);
}
