/**************************************************************************/
/*                                                                        */
/*  This file is part of FISSC 3.                                           */
/*                                                                        */
/*  You can redistribute it and/or modify it under the terms of the GNU   */
/*  Lesser General Public License as published by the Free Software       */
/*  Foundation, version 3.0.                                              */
/*                                                                        */
/*  It is distributed in the hope that it will be useful,                 */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of        */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         */
/*  GNU Lesser General Public License for more details.                   */
/*                                                                        */
/*  See the GNU Lesser General Public License version 3.0                 */
/*  for more details (enclosed in the file LICENSE).                      */
/*                                                                        */
/**************************************************************************/

/*$
  @name = VerifyPIN_0
  @feature = verifyPIN
  @fault-model = test-inversion
  @attack-scenario = oracle
  @countermeasure = none
  @maintainers = Etienne Boespflug, VERIMAG
  @authors = Lionel Rivière, SERTIF Consortium
  @version 3.0
*/

#include <stdio.h>

#include "interface.h"
#include "types.h"
#include "lazart.h"

extern UBYTE g_countermeasure;
extern BOOL g_authenticated;
extern SBYTE g_ptc;

BOOL verifyPIN(void);

int main()
{
#ifdef SYM
    initialize_sym();
#else
    initialize();
#endif 
    verifyPIN();
#ifdef LZ_ICA
#ifdef USE_ICA_ORACLE
    LAZART_ORACLE(g_countermeasure != 0 && g_authenticated == 1);
#elif USE_ICA_PTC_ORACLE
    LAZART_ORACLE(g_countermeasure != 0 && g_ptc != 2);
#elif USE_ICA_2_ORACLE
    LAZART_ORACLE(g_countermeasure != 0 && (g_authenticated == 1 && g_ptc != 2));
#elif USE_ICA_X2_ORACLE
    LAZART_ORACLE(g_countermeasure != 0 && (g_authenticated == 1 || g_ptc != 2));
#else 
    LAZART_ORACLE(g_countermeasure != 0);
#endif
#else
    LAZART_ORACLE(oracle());
#endif 
    /*printf("toto^,")
    verifyPIN();
    printf("[@] g_countermeasure = %i, g_authenticated = %i, g_ptc = %i\n", g_countermeasure, g_authenticated, g_ptc);
    
#ifdef LZ_ICA
    LAZART_ORACLE(g_countermeasure != 0);
#else
    LAZART_ORACLE(oracle());
#endif */

    return 0;
}
